﻿Imports System.Drawing.Drawing2D
Imports System.Math

Public Class Form1
    ' The points.
    Private Points() As PointF

    ' The solutions.
    Private Solutions As List(Of Integer())

    ' The solution we should display.
    Private CurrentSolution As Integer = 100

    ' Define the points and solutions.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DoubleBuffered = True

        ' Define the points.
        Dim dy As Single = CSng(ClientSize.Height / 4)
        Dim dx As Single = CSng(dy / Math.Sqrt(3))
        Dim top_x As Single = CSng(ClientSize.Width / 2)
        Dim top_y As Single = -dy / 2
        Points = New PointF() _
        { _
            New PointF(top_x - dx, top_y + dy), _
            New PointF(top_x + dx, top_y + dy), _
            New PointF(top_x - 2 * dx, top_y + 2 * dy), _
            New PointF(top_x - 0 * dx, top_y + 2 * dy), _
            New PointF(top_x + 2 * dx, top_y + 2 * dy), _
            New PointF(top_x - 3 * dx, top_y + 3 * dy), _
            New PointF(top_x - 1 * dx, top_y + 3 * dy), _
            New PointF(top_x + 1 * dx, top_y + 3 * dy), _
            New PointF(top_x + 3 * dx, top_y + 3 * dy), _
            New PointF(top_x - 2 * dx, top_y + 4 * dy), _
            New PointF(top_x - 0 * dx, top_y + 4 * dy), _
            New PointF(top_x + 2 * dx, top_y + 4 * dy) _
        }

        ' Define the solutions.
        Solutions = New List(Of Integer())()

        ' Insert your code here...
        Dim i As Short = 0
        Dim i2 As Short = 1
        Dim i3 As Short = 2
        Dim bolCont As Boolean = True
        Dim bolMatch As Boolean = False
        Do
            Do
                bolMatch = checkSquare(i, i2, i3)
                If bolMatch = True Then
                    Solutions.Add(New Integer() {CInt(i), CInt(i2), CInt(i3)})
                End If
                i3 = CShort(i3 + 1)
                If i3 = 12 Then
                    i2 = CShort(i2 + 1)
                    i3 = CShort(i2 + 1)
                End If
            Loop While i2 < 11
            i = CShort(i + 1)
            i2 = CShort(i + 1)
            i3 = CShort(i2 + 1)
        Loop While i < 9
    End Sub

    ' Draw the circles and any triangles currently defined.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.SmoothingMode = SmoothingMode.AntiAlias

        ' Draw the points.
        Const radius As Single = 5
        For Each pt As PointF In Points
            e.Graphics.FillEllipse(Brushes.Blue, _
                pt.X - radius, pt.Y - radius, _
                2 * radius, 2 * radius)
        Next pt

        ' Draw the current solution.
        If (CurrentSolution < 0) Then
            ' Draw all solutions.
            For i As Integer = 0 To Solutions.Count - 1
                DrawSolution(e.Graphics, i)
            Next i
        Else
            ' Draw the current solution.
            DrawSolution(e.Graphics, CurrentSolution)
        End If
    End Sub

    ' Draw a solution.
    Private Sub DrawSolution(ByVal gr As Graphics, ByVal solution_num As Integer)
        If (solution_num >= Solutions.Count) Then Return

        ' Make a list of the points in this solution.
        Dim pts As New List(Of PointF)()
        For Each i As Integer In Solutions(solution_num)
            pts.Add(Points(i))
        Next i
        gr.DrawPolygon(Pens.Red, pts.ToArray())
    End Sub

    ' Start showing solutions.
    Private Sub btnShowSolutions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowSolutions.Click
        ' Disable the button.
        btnShowSolutions.Enabled = False

        ' Start at the first solution.
        CurrentSolution = 0

        ' Start the timer.
        tmrChangeSolution.Enabled = True

        ' Redraw.
        Refresh()
    End Sub

    ' Show the next solution.
    Private Sub tmrChangeSolution_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrChangeSolution.Tick
        ' Increment CurrentSolution. If the result is greater than the
        ' last solution's index, disable the timer.
        CurrentSolution += 1
        tmrChangeSolution.Enabled = (CurrentSolution < Solutions.Count)

        ' If we're done drawing, enable the button.
        btnShowSolutions.Enabled = (Not tmrChangeSolution.Enabled)

        ' Redraw.
        Refresh()
    End Sub

    ' Show all of the solutions.
    Private Sub btnShowAllSolutions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowAllSolutions.Click
        CurrentSolution = -1
        tmrChangeSolution.Enabled = False
        btnShowSolutions.Enabled = True
        Refresh()
    End Sub

    Private Function checkSquare(ByVal p1 As Short, ByVal p2 As Short, ByVal p3 As Short) As Boolean
        Dim side1 As Double
        Dim side2 As Double
        Dim side3 As Double
        side1 = Sqrt((Abs(Points(p1).X - Points(p2).X) ^ 2) + (Abs(Points(p1).Y - Points(p2).Y) ^ 2))
        side2 = Sqrt((Abs(Points(p3).X - Points(p2).X) ^ 2) + (Abs(Points(p3).Y - Points(p2).Y) ^ 2))
        side3 = Sqrt((Abs(Points(p3).X - Points(p1).X) ^ 2) + (Abs(Points(p3).Y - Points(p1).Y) ^ 2))

        If Math.Round(side1, 2) = Math.Round(side2, 2) Then
            If Math.Round(side2, 2) = Math.Round(side3, 2) Then
                Return True
            Else
                Return False
            End If
        End If

        If Math.Round(side1, 6) = Math.Round(side2, 6) Then
            If Math.Round(side2, 6) = Math.Round(side3, 6) Then
                'MessageBox.Show(String.Format("They all match" & vbCrLf & "p1 = {0}, p2 = {1}, p3 = {2}", p1, p2, p3))
                'MessageBox.Show(String.Format("Side1 = {0}, Side2 = {1}, Side3 = {2}", side1, side2, side3))
                Return True
            Else
                Return False
            End If
        End If
    End Function
End Class
