﻿
Imports System.Drawing

Public Class Form1

    ' The points.
    Private Points() As PointF

    ' The solutions.
    Private Solutions As List(Of Integer())

    ' The solution we should display.
    Private CurrentSolution As Integer = 100

    ' Define the points and solutions.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal _
        e As System.EventArgs) Handles MyBase.Load
        DoubleBuffered = True

        ' Define the points.
        Dim dy As Single = CSng(ClientSize.Height / 4)
        Dim dx As Single = CSng(dy / Math.Sqrt(3))
        Dim top_x As Single = CSng(ClientSize.Width / 2)
        Dim top_y As Single = -dy / 2
        Points = New PointF() _
        { _
            New PointF(top_x - dx, top_y + dy), _
            New PointF(top_x + dx, top_y + dy), _
            New PointF(top_x - 2 * dx, top_y + 2 * dy), _
            New PointF(top_x - 0 * dx, top_y + 2 * dy), _
            New PointF(top_x + 2 * dx, top_y + 2 * dy), _
            New PointF(top_x - 3 * dx, top_y + 3 * dy), _
            New PointF(top_x - 1 * dx, top_y + 3 * dy), _
            New PointF(top_x + 1 * dx, top_y + 3 * dy), _
            New PointF(top_x + 3 * dx, top_y + 3 * dy), _
            New PointF(top_x - 2 * dx, top_y + 4 * dy), _
            New PointF(top_x - 0 * dx, top_y + 4 * dy), _
            New PointF(top_x + 2 * dx, top_y + 4 * dy) _
        }

        ' Define the solutions.
        Solutions = New List(Of Integer())()

        ' Insert your code here...

        Dim Side1 As Double
        Dim Side2 As Double
        Dim Side3 As Double

        ' Loop through all the points except the last one
        For S1 As Integer = 0 To Points.Count - 2

            ' Loop through all points after S1
            For S2 As Integer = S1 + 1 To Points.Count - 1

                ' Get length between points S1 and S2
                Side1 = ((Points(S1).X - Points(S2).X) ^ 2) + _
                        ((Points(S1).Y - Points(S2).Y) ^ 2)

                ' Loop through all points after S2
                For S3 As Integer = S2 + 1 To Points.Count - 1

                    ' Get length between points S2 and S3
                    Side2 = ((Points(S2).X - Points(S3).X) ^ 2) + _
                            ((Points(S2).Y - Points(S3).Y) ^ 2)

                    ' If the two sides are equal...check back to S1
                    If CInt(Side1) = CInt(Side2) Then

                        ' Get length between points S3 and S1
                        Side3 = ((Points(S3).X - Points(S1).X) ^ 2) + _
                                ((Points(S3).Y - Points(S1).Y) ^ 2)

                        ' When S3=S1 then an equilateral triangle exists!
                        If CInt(Side3) = CInt(Side1) Then
                            Solutions.Add(New Integer() {S1, S2, S3})
                        End If
                    End If
                Next
            Next
        Next

    End Sub


    ' Draw the circles and any triangles currently defined.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As  _
        System.Windows.Forms.PaintEventArgs) Handles Me.Paint

        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias

        ' Draw the points.
        Const radius As Single = 5
        For Each pt As PointF In Points
            e.Graphics.FillEllipse(Brushes.Blue, _
                pt.X - radius, pt.Y - radius, _
                2 * radius, 2 * radius)
        Next pt

        ' Draw the current solution.
        If (CurrentSolution < 0) Then
            ' Draw all solutions.
            For i As Integer = 0 To Solutions.Count - 1
                DrawSolution(e.Graphics, i)
            Next i
        Else
            ' Draw the current solution.
            DrawSolution(e.Graphics, CurrentSolution)
        End If
    End Sub

    ' Draw a solution.
    Private Sub DrawSolution(ByVal gr As Graphics, ByVal _
        solution_num As Integer)
        If (solution_num >= Solutions.Count) Then Return

        ' Make a list of the points in this solution.
        Dim pts As New List(Of PointF)()
        For Each i As Integer In Solutions(solution_num)
            pts.Add(Points(i))
        Next i
        gr.DrawPolygon(Pens.Red, pts.ToArray())
    End Sub

    ' Start showing solutions.
    Private Sub btnShowSolutions_Click(ByVal sender As System.Object, _
                                       ByVal e As System.EventArgs) Handles btnShowSolutions.Click

        ' Disable the button.
        btnShowSolutions.Enabled = False

        ' Start at the first solution.
        CurrentSolution = 0

        ' Start the timer.
        tmrChangeSolution.Enabled = True

        ' Redraw.
        Refresh()

    End Sub

    ' Show the next solution.
    Private Sub tmrChangeSolution_Tick(ByVal sender As  _
        System.Object, ByVal e As System.EventArgs) Handles _
        tmrChangeSolution.Tick
        ' Increment CurrentSolution. If the result is greater
        ' than the
        ' last solution's index, disable the timer.
        CurrentSolution += 1
        tmrChangeSolution.Enabled = (CurrentSolution < _
            Solutions.Count)

        ' If we're done drawing, enable the button.
        btnShowSolutions.Enabled = (Not _
            tmrChangeSolution.Enabled)

        ' Redraw.
        Refresh()
    End Sub

    ' Show all of the solutions.
    Private Sub btnShowAllSolutions_Click(ByVal sender As  _
        System.Object, ByVal e As System.EventArgs) Handles _
        btnShowAllSolutions.Click
        CurrentSolution = -1
        tmrChangeSolution.Enabled = False
        btnShowSolutions.Enabled = True
        Refresh()
    End Sub

End Class
